package cn.com.infosec.util;

import java.io.ByteArrayOutputStream;
import java.util.Vector;

public final class Strings {
   public static String fromUTF8ByteArray(byte[] bytes) {
      int var1 = 0;
      int var2 = 0;

      while(var1 < bytes.length) {
         ++var2;
         if ((bytes[var1] & 240) == 240) {
            ++var2;
            var1 += 4;
         } else if ((bytes[var1] & 224) == 224) {
            var1 += 3;
         } else if ((bytes[var1] & 192) == 192) {
            var1 += 2;
         } else {
            ++var1;
         }
      }

      char[] var3 = new char[var2];
      var1 = 0;

      int var4;
      for(var2 = 0; var1 < bytes.length; var2 = var4) {
         char var5;
         if ((bytes[var1] & 240) == 240) {
            int var10001 = var2;
            int var10002 = ((bytes[var1] & 3) << 18 | (bytes[var1 + 1] & 63) << 12 | (bytes[var1 + 2] & 63) << 6 | bytes[var1 + 3] & 63) - 65536;
            var4 = (char)(((bytes[var1] & 3) << 18 | (bytes[var1 + 1] & 63) << 12 | (bytes[var1 + 2] & 63) << 6 | bytes[var1 + 3] & 63) - 65536 >> 10 | '\ud800');
            var5 = (char)(var10002 & 1023 | '\udc00');
            ++var2;
            var3[var10001] = (char)var4;
            var1 += 4;
         } else if ((bytes[var1] & 224) == 224) {
            var5 = (char)((bytes[var1] & 15) << 12 | (bytes[var1 + 1] & 63) << 6 | bytes[var1 + 2] & 63);
            var1 += 3;
         } else if ((bytes[var1] & 208) == 208) {
            var5 = (char)((bytes[var1] & 31) << 6 | bytes[var1 + 1] & 63);
            var1 += 2;
         } else if ((bytes[var1] & 192) == 192) {
            var5 = (char)((bytes[var1] & 31) << 6 | bytes[var1 + 1] & 63);
            var1 += 2;
         } else {
            var5 = (char)(bytes[var1] & 255);
            ++var1;
         }

         var4 = var2 + 1;
         var3[var2] = var5;
      }

      return new String(var3);
   }

   public static byte[] toUTF8ByteArray(String string) {
      ByteArrayOutputStream string1;
      string1 = new ByteArrayOutputStream.<init>();
      char[] var1 = string.toCharArray();

      for(int var2 = 0; var2 < var1.length; ++var2) {
         int var3;
         if ((var3 = var1[var2]) < 128) {
            string1.write(var3);
         } else if (var3 < 2048) {
            string1.write(var3 >> 6 | 192);
            string1.write(var3 & 63 | 128);
         } else if (var3 >= 55296 && var3 <= 57343) {
            if (++var2 >= var1.length) {
               throw new IllegalStateException("invalid UTF-16 codepoint");
            }

            char var4 = var1[var2];
            if (var3 > 56319) {
               throw new IllegalStateException("invalid UTF-16 codepoint");
            }

            int var10001 = var3 = ((var3 & 1023) << 10 | var4 & 1023) + 65536;
            string1.write(var3 >> 18 | 240);
            string1.write(var3 >> 12 & 63 | 128);
            string1.write(var3 >> 6 & 63 | 128);
            string1.write(var10001 & 63 | 128);
         } else {
            string1.write(var3 >> 12 | 224);
            string1.write(var3 >> 6 & 63 | 128);
            string1.write(var3 & 63 | 128);
         }
      }

      return string1.toByteArray();
   }

   public static String toUpperCase(String string) {
      boolean var1 = false;
      char[] var2 = string.toCharArray();

      for(int var3 = 0; var3 != var2.length; ++var3) {
         char var4 = var2[var3];
         if ('a' <= var4 && 'z' >= var4) {
            var1 = true;
            var2[var3] = (char)(var4 - 97 + 65);
         }
      }

      if (var1) {
         return new String(var2);
      } else {
         return string;
      }
   }

   public static String toLowerCase(String string) {
      boolean var1 = false;
      char[] var2 = string.toCharArray();

      for(int var3 = 0; var3 != var2.length; ++var3) {
         char var4 = var2[var3];
         if ('A' <= var4 && 'Z' >= var4) {
            var1 = true;
            var2[var3] = (char)(var4 - 65 + 97);
         }
      }

      if (var1) {
         return new String(var2);
      } else {
         return string;
      }
   }

   public static byte[] toByteArray(String string) {
      int var1;
      byte[] var2 = new byte[var1 = string.length()];

      for(int var3 = 0; var3 != var1; ++var3) {
         var2[var3] = (byte)string.charAt(var3);
      }

      return var2;
   }

   public static String[] split(String input, char delimiter) {
      Vector var2;
      var2 = new Vector.<init>();
      boolean var3 = true;

      int var4;
      while(var3) {
         if ((var4 = input.indexOf(delimiter)) > 0) {
            var2.addElement(input.substring(0, var4));
            input = input.substring(var4 + 1);
         } else {
            var3 = false;
            var2.addElement(input);
         }
      }

      String[] var5 = new String[var4 = var2.size()];

      for(int input1 = 0; input1 != var4; ++input1) {
         var5[input1] = (String)var2.elementAt(input1);
      }

      return var5;
   }
}
